
// a simple Java program using fork-join synchronization

class SlowSum extends Thread {
    int [] arr;
    int    start_index;
    int    len;
    int    which_thread;
    int    ans;

    SlowSum(int [] _arr, int _start_index, int _len, int _which_thread) {
	arr = _arr;
	start_index = _start_index;
	len = _len;
	which_thread = _which_thread;
	ans = 0;
    }

    void finished_iter(int iter) {
	if(!JavaThreads1.SHOW_RESULTS)
	    return;
	if(iter % 10 != 0)
	    return;
	System.out.println("thread: "+which_thread+", sum so far: "+ans+"\n");
	System.out.flush();
    }

    public void run() {
	for(int i=0; i < len; ++i) {
	    int num = arr[start_index+i];
	    while(num != 0) { // a silly, slow algorithm for ans+=num
		--num;
		++ans;
	    }
	    finished_iter(i);
	}
    }
}

class JavaThreads1 {
    static final int NUM_THREADS = 4;
    static final boolean SHOW_RESULTS = false;
    static final int ARRAY_SIZE = SHOW_RESULTS ? 160 : 16000;
    static final int PER_THREAD_SIZE = ARRAY_SIZE / NUM_THREADS;

    static {
	if (ARRAY_SIZE % NUM_THREADS != 0) {
	    System.err.println("will miss some array elements");
	    System.exit(1);
	}
    }

    static void big_sum() {
	int []     arr = new int[ARRAY_SIZE];
	int        i;
	SlowSum [] threads = new SlowSum[NUM_THREADS];
	int        total_ans=0;
	for(i=0; i < ARRAY_SIZE; ++i)
	    arr[i] = (i+1)*50;

	for(i=0; i < NUM_THREADS; ++i) {
	    threads[i] = new SlowSum(arr,i*PER_THREAD_SIZE,PER_THREAD_SIZE,i);
	    threads[i].start();
	}
	for(i=0; i < NUM_THREADS; ++i)
	    try {
		threads[i].join();
	    } catch (InterruptedException e) {
		System.err.println("advanced issue occurred");
	    }

	for(i=0; i < NUM_THREADS; ++i)
	    total_ans += threads[i].ans;
	System.out.println("total answer: " + total_ans + "\n");
    }

    public static void main(String[] args) {
	big_sum();
    }
}